%global forgeurl https://gitlab.com/libblkio/libblkio
%global commit c8f5ed9a1460d90a522bda55da09f013fa7da61c
# Upstream has not tagged any versions so far.
Version:       0.1
%forgemeta

Summary:       Block device I/O library
Name:          libblkio
Release:       1%{?dist}
URL:           %{forgeurl}
Source0:       %{forgesource}
License:       ASL 2.0 or MIT

# Bundled missing dependencies.
#
# These were created by running "cargo vendor" in the source tree
# and then making a tarball of just the following directories:
# vendor/concat-idents
# vendor/io-uring
# vendor/memfd
# vendor/winapi*
Source1:       vendor.tar.gz

# Basic build requirements.
BuildRequires: gcc, gcc-c++
BuildRequires: make
BuildRequires: meson
BuildRequires: rust-packaging >= 21
BuildRequires: rustfmt
BuildRequires: cargo
BuildRequires: python3-docutils
BuildRequires: pkgconf
BuildRequires: crate(autocfg/default)
BuildRequires: crate(bitflags/default)
BuildRequires: crate(cc/default)
BuildRequires: crate(cfg-if/default)
# BuildRequires: crate(concat-idents...)
BuildRequires: crate(const-cstr/default)
# BuildRequires: crate(io-uring...)
BuildRequires: crate(lazy_static/default)
BuildRequires: crate(libc/default)
# BuildRequires: crate(memfd...)
BuildRequires: crate(memmap/default)
BuildRequires: crate(memoffset/default)
BuildRequires: crate(nix/default)
BuildRequires: crate(proc-macro2/default)
BuildRequires: crate(syn/default)
BuildRequires: crate(unicode-xid/default)
BuildRequires: crate(virtio-bindings/default)


%description
libblkio is a library for high-performance block device I/O with
support for multi-queue devices. A C API is provided so that
applications can use the library from most programming languages.


%package devel
Summary:       Development tools for %{name}
Requires:      %{name}%{_isa} = %{version}-%{release}


%description devel
This package contains development tools for %{name}.


%prep
%forgesetup
tar zxf %{SOURCE1}

cat >> Cargo.toml <<EOF
[patch.crates-io]
concat-idents = { path = 'vendor/concat-idents' }
io-uring = { path = 'vendor/io-uring' }
memfd = { path = 'vendor/memfd' }
winapi = { path = 'vendor/winapi' }
winapi-i686-pc-windows-gnu = { path = 'vendor/winapi-i686-pc-windows-gnu' }
winapi-x86_64-pc-windows-gnu = { path = 'vendor/winapi-x86_64-pc-windows-gnu' }
EOF
%cargo_prep
sed -e 's/--locked/--offline/' -i src/cargo-build.sh

%build
%{meson}
%{meson_build}


%install
%{meson_install}

pushd %{buildroot}%{_libdir}
ln -s libblkio.so libblkio.so.0
ln -s libblkio.so.0 libblkio.so.0.0
popd


%files
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_libdir}/libblkio.so.0*


%files devel
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_includedir}/blkio.h
%{_libdir}/libblkio.so
%{_libdir}/pkgconfig/blkio.pc
%{_mandir}/man3/blkio.3*


%changelog
* Tue Sep 06 2022 Richard W.M. Jones <rjones@redhat.com> - 0.1-1
- Initial package
